#Extend_Trim_Faces.　（Joint_Thinwall(Face)）
# Copyright TAK2
#------------------------------------------------------------------------
#使い方：
#1.伸ばしたい面を選択（辺を含んだ状態）
#2.伸ばし先の面を選択（辺を含まなくてもOK・辺を含むとジョイントモード）
#注意点　ZBIM以外の属性は継承されない。
#How To USE
#1.select Face for extend.(with edge)
#2.select Face for extend to.(not with edge.if select with edge then Joint)
#090904:
#Bug FIx... Enable to edit group and component instanse.
#Change file name to Extend_Trim_Faces
#090502:
#Beta版FIX
#名称をChamfer_thinwallからJoint_Thinwallに変更
#同じ面を選択した場合、距離の変更
#130324
#あまり役に立っていないダイアログを廃止

require 'sketchup.rb'
class Joint_Thinwall_Set
	class Joint_Thinwall
	#ZBIM_PREFIX = "ZBIM"

		def Joint_Thinwall.show_webdialog
			model = Sketchup.active_model
			@lang = Sketchup.get_locale.upcase
			cr = "\n"
			shtm = '<html lang="ja"><head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />'
			shtm = shtm + "<script type='text/javascript'>"+ cr
			shtm = shtm + "<!--"+ cr
			shtm = shtm + "function startjoint(obj) {" + cr
			shtm = shtm + "window.location='skp:startjoint';"
			shtm = shtm + "}" + cr
			shtm = shtm + "-->" + cr
			shtm = shtm + "</Script>" + cr
			shtm = shtm + "</head><body scroll=yes>" + cr
			shtm = shtm + "<form name='form1' >"
			#if @lang == "JA" or @lang == "JP"
				##shtm = shtm + "絶対高さ<input name='jt_dist' id='JT_DIST' type='text' width='200' value='2500' ></input>"

				shtm = shtm + "<select name='jt_mode' id='jt_mode' style='width:150px; height: 20px; font-size: 10px; text-align: left; vertical-align: middle' >"
				shtm = shtm + "<OPTION selected value='erase_edge'>Erase Origin Edge</OPTION>"+cr
				shtm = shtm + "<OPTION value='keep_edge'>Keep Origin Edge</OPTION>"+cr
				shtm = shtm + "</select>"+cr

				shtm = shtm + "<br><input type='button' name='btn_startjoint' value='Start' onClick='startjoint(this)'>"
			#else
			#    shtm = shtm + "Abusolute Height<input name='jt_dist' id='JT_DIST' type='text' width='200' value='2500' ></input>"
			#    shtm = shtm + "<br><input type='button' name='btn_startjoint' value='select start!' onClick='startjoint(this)'>"
			#end
			shtm = shtm + "</form>"
			if @lang == "JA" or @lang == "JP"
				@wdlg = UI::WebDialog.new("面と面を突き付ける-設定", true, "et_faces", 100, 100, 150, 150, true)
			else
				@wdlg = UI::WebDialog.new("Extend and Trim Faces--setting", true, "et_faces", 100, 100, 150, 150, true)
			end
			@wdlg.set_html(shtm)
			@wdlg.add_action_callback("startjoint"){|d,p|
				@etf_keep_edge = false
				@etf_keep_edge = true if @wdlg.get_element_value("jt_mode") == "keep_edge"
				Sketchup.active_model.select_tool Joint_Thinwall.new
			}
			@wdlg.show
			#@wdlg.set_size 248,125
			#@wdlg.set_position 500,200
		end

		def initialize
			@lang = ""#Sketchup.get_locale.upcase
			@etf_keep_edge = false
			@ip = Sketchup::InputPoint.new
			reset
		end

		def reset
			@ip.clear
			@pt1 = Geom::Point3d.new
			@pt2 = Geom::Point3d.new
			@state = 0
			model = Sketchup.active_model
			@selection = model.selection
			@selection.clear
			if @lang == "JA" or @lang == "JP"
				Sketchup::set_status_text "接続する面の選択　１"
			else
				Sketchup::set_status_text "Select 1st Face"
			end
		end

		def activate
			self.reset
		end

		def height_byDistance(view, fc1, ed1)
			#選択されているエッジを最後に消すか？エッジに接続する面が１の場合は消す
			erase_edge = false
			erase_edge = true if ed1.faces.size == 1
			#fc1法線ベクトルをed1辺で90度回転する
			nvec1 = fc1.normal
			#Z軸と平行だったら終了
			if nvec1.parallel? Geom::Vector3d.new(0,0,1)
				return
			end
			#zheight = @wdlg.get_element_value("JT_DIST").to_f.mm
			#horplane = [Geom::Point3d.new(0,0,zheight), Geom::Vector3d.new(0,0,1)]
			plane1 = fc1.plane
			
			#面の中でエッジに接続するほかのエッジを探す。(ed1始点)
			#他のエッジとed1が平行だった場合はnvec1を利用する。
			aed1 = get_another_edge fc1 , ed1 , ed1.start
			vec1 = ed1.start.position.vector_to ed1.end.position
			vec2 = aed1.start.position.vector_to aed1.end.position
			if vec1.parallel? vec2
				bline = [ed1.start.position , nvec1 ]
			else
				bline = [aed1.start.position , aed1.end.position ]
			end
			#面の中でエッジに接続するほかのエッジを探す。(ed1終点)始点と同様
			aed2 = get_another_edge fc1 , ed1 , ed1.end
			vec2 = aed2.start.position.vector_to aed2.end.position
			if vec1.parallel? vec2
				tline = [ed1.end.position , nvec1 ]
			else
				tline = [aed2.start.position , aed2.end.position ]
			end

			ipts = []
			tempipt = Geom.intersect_line_line bline,iline
			ipts.push tempipt if not tempipt == nil
			tempipt = Geom.intersect_line_line tline,iline
			ipts.push tempipt if not tempipt == nil
			#if not ipts[1] == ed1.end.position
			ipts.push ed1.end.position
			#end
			ipts.push ed1.start.position #if not ipts[0] == ed1.start.position
			ipts.delete( nil )
			ipts.uniq!

			model=Sketchup.active_model
			entities=model.active_entities
			if ipts.size > 2
				oNew=entities.add_face ipts
				oNew.material, oNew.back_material = fc1.material,fc1.back_material
				oNew.layer = fc1.layer
				for eg in oNew.edges
					eg.layer = fc1.layer
				end
				#属性のコピー
				dic = fc1.attribute_dictionary(ZBIM_PREFIX, true)
				oNewdic = oNew.attribute_dictionary(ZBIM_PREFIX, true)
				dic.each {|k,v|
					oNewdic[k] = v
				}
				#余分な辺を削除する
				ted1 = get_another_edge( nil ,ed1 , ed1.start) if ed1.start.edges.size == 2
				ted2 = get_another_edge( nil ,ed1 , ed1.end) if ed1.end.edges.size == 2
				##if erase_edge == true
				if @keep_edge == false and erase_edge == true
					ted1.erase! if not ted1 == nil
					ted2.erase! if not ted2 == nil
					ed1.erase!
				end
			end # if
		end

		def chamfer_face(view)
			#return if @fc1.parent.typename != "Model" or @fc2.parent.typename != "Model"
		#tf1 = @fc1.parent.transformation if @fc1.parent.kind_of? Sketchup::ComponentInstance or @fc1.parent.kind_of? Sketchup::Group
		#tf2 = @fc1.parent.transformation if @fc2.parent.kind_of? Sketchup::ComponentInstance or @fc2.parent.kind_of? Sketchup::Group
			plane1 = @fc1.plane
			plane1 = [@fc1.vertices[0].position.transform(@tf1),@fc1.normal.transform(@tf1)] if @tf1 != nil
			plane2 = @fc2.plane
			plane2 = [@fc2.vertices[0].position.transform(@tf2),@fc2.normal.transform(@tf2)] if @tf2 != nil
			
			iline = Geom.intersect_plane_plane plane1, plane2
			if iline == nil and @ed2 != nil
				p3pt1 = @ed2.vertices[0].position
				p3pt1.transform!(@tf2) if @tf2 != nil
				p3pt2 = @ed2.vertices[1].position
				p3pt2.transform!(@tf2) if @tf2 != nil
				p3pt3 = @ed1.vertices[0].position
				p3pt3.transform!(@tf1) if @tf1 != nil
				p3v31 = p3pt3.vector_to(p3pt1)
				p3v32 = p3pt3.vector_to(p3pt2)
				p3v12 = p3pt1.vector_to(p3pt2)
				f1v = @fc1.normal
				f1v.transform(@tf1) if @tf1 != nil
				plane3 = [ p3pt3 , p3v31.cross(p3v32) ]
				iline = Geom.intersect_plane_plane plane1, plane3
				if iline == nil
					plane4 = [ p3pt1 , p3v12.cross(f1v) ]
					iline = Geom.intersect_plane_plane plane1, plane4
					@ed2 = nil
				end
			end
			if iline == nil
				if @lang == "JA" or @lang == "JP"
					Sketchup::set_status_text "面が交差しません"
				else
					Sketchup::set_status_text "Each Faces not Intersect with"
				end
				self.reset
			end
			Sketchup.active_model.start_operation "Extend_Trim_Faces"# , true 
			make_chamferface2 @fc1,@ed1,iline,@tf1
			if not @ed2 == nil##二つめのエッジが選択されている場合
				if not @fc2.edges.index(@ed2) == nil
					#選択した面2が、先作成された面で分断されているない場合
					make_chamferface2 @fc2,@ed2,iline,@tf2
				else
					#選択した面2が、先作成された面で分断されている場合
					#余分な辺を削除するか
					erase_edge = true if @ed2.faces.size == 1#edに他の面が接続されていない場合true
					ted1 = get_another_edge( nil ,@ed2 , @ed2.start) if @ed2.start.edges.size == 2
					ted2 = get_another_edge( nil ,@ed2 , @ed2.end) if @ed2.end.edges.size == 2
					if @etf_keep_edge != true and erase_edge == true
						ted1.erase! if not ted1 == nil
						ted2.erase! if not ted2 == nil
						@ed2.erase!
					end
				end
			end
			view.invalidate
			Sketchup.active_model.commit_operation
		end
		#面に在る辺の点に接続する他の辺をさがす
		def get_another_edge( fc1 ,ed1 , pt1)
			aed = nil
			if not fc1 == nil
				for ed in fc1.edges
					aed = ed if not ed == ed1 and ( not ed.vertices.index(pt1) == nil )
				end
			else
				for ed in pt1.edges
					aed = ed if not ed == ed1 and ( not ed.vertices.index(pt1) == nil )
				end
			end
			return aed
		end
		#edgeも選択されていた場合
		def make_chamferface2( fc1, ed1 , iline , tf )
			#選択されているエッジを最後に消すか？エッジに接続する面が１の場合は消す
			erase_edge = false
			erase_edge = true if ed1.faces.size == 1
			pivot = Geom::Point3d.new 0,0,0

		if tf == nil
			tf = Geom::Transformation.new pivot
		end
			nvec1 = fc1.normal
			nvec1.transform! tf
			axis = ed1.start.position.vector_to ed1.end.position
			axis.transform! tf
			t1 = Geom::Transformation.rotation pivot, axis, ( Math::PI / 2)
			nvec1.transform! t1
			
			#面の中でエッジに接続するほかのエッジを探す。
			aed1 = get_another_edge fc1 , ed1 , ed1.start
			return if aed1 == nil
			vec1 = ed1.start.position.vector_to ed1.end.position
			vec2 = aed1.start.position.vector_to aed1.end.position
			bline = []
			if vec1.parallel? vec2
				bline = [ed1.start.position.transform(tf), nvec1 ]
			else
				bline = [aed1.start.position.transform(tf) , aed1.end.position.transform(tf) ]
			end
			aed2 = get_another_edge fc1 , ed1 , ed1.end
			vec2 = aed2.start.position.vector_to aed2.end.position
			if vec1.parallel? vec2
				tline = [ed1.end.position.transform(tf) , nvec1 ]
			else
				tline = [aed2.start.position.transform(tf) , aed2.end.position.transform(tf) ]
			end

			opts = []
			tempipt = Geom.intersect_line_line bline,iline
			opts.push tempipt if not tempipt == nil
			tempipt = Geom.intersect_line_line tline,iline
			opts.push tempipt if not tempipt == nil
			#if not ipts[1] == ed1.end.position
			opts.push ed1.end.position.transform(tf)
			#end
			opts.push ed1.start.position.transform(tf) #if not ipts[0] == ed1.start.position
			opts.delete( nil )
			opts.uniq!
			ipts = uniq_pts(opts)
			ipts.map!{|pt| tf.inverse * pt}
			#model=Sketchup.active_model
			comp = fc1.parent
			entities= comp.entities
			if ipts.size > 2
				oNew=entities.add_face ipts
				oNew.material, oNew.back_material = fc1.material,fc1.back_material
				oNew.layer = fc1.layer
				for eg in oNew.edges
					eg.layer = fc1.layer
				end
				#属性のコピー
				copy_attributes fc1,oNew if (fc1.attribute_dictionaries != nil )
				#dic = fc1.attribute_dictionary(ZBIM_PREFIX, true)
				#oNewdic = oNew.attribute_dictionary(ZBIM_PREFIX, true)
				#dic.each {|k,v|
				#	oNewdic[k] = v
				#}
				
				#余分な辺を削除する
				ted1 = get_another_edge( nil ,ed1 , ed1.start) if ed1.start.edges.size == 2
				ted2 = get_another_edge( nil ,ed1 , ed1.end) if ed1.end.edges.size == 2
				if @etf_keep_edge != true and erase_edge == true
					ted1.erase! if not ted1 == nil
					ted2.erase! if not ted2 == nil
					ed1.erase!
				end
			end # if
		end

		def copy_attributes( ent1,ent2 )
			ent1.attribute_dictionaries.each{|dic|
				fcdic = ent2.attribute_dictionary(dic.name, true)
				dic.each{ |key,value|
					fcdic[key] = value
				}
				fcdic = nil
			}
		end#def copy attributes

		def uniq_pts( pts )#ptを比較して同じptを消去
			newpts = []
			if pts.length > 1
				pts.each{|pt|
					chk = false
					newpts.each{|pt2|
						chk = true if pt2 == pt
					}
					newpts.push pt if chk == false
				}
			end
			return newpts
		end
		def increment_state(view)
			@state += 1
			case @state
			when 1
				if @lang == "JA" or @lang == "JP"
					Sketchup::set_status_text "接続する面の選択　２"
				else
					Sketchup::set_status_text "Select 2nd Face"
				end
			when 2
				if @fc1 == @fc2
					#self.height_byDistance(view, @fc1 , @ed1)
				else
					self.chamfer_face(view)
				end
				self.reset
			end
		end

		def onMouseMove(flags, x, y, view)

		end

		def onLButtonDown(flags, x, y, view)
			@ip.pick(view,x,y)
			face = @ip.face
			model = Sketchup.active_model
		  case @state
		  when 0
			if face != nil
				#if face.parent.parent == model
					@fc1 = nil
					@ed1 = nil
					@tf1 = nil
					if @ip.face
						@fc1 = @ip.face
						@tf1 = @ip.transformation
					end
					@ed1 = @ip.edge if @ip.edge
					@ps1 = @ip.position
					@selection.add @fc1 if @fc1 and @ed1
					@selection.add @ed1 if @fc1 and @ed1
					self.increment_state(view) if @fc1 and @ed1
				#end
			end
		  when 1
			if face!=nil
					@fc2 = nil
					@ed2 = nil
					@tf2 = nil
					if @ip.face
						@fc2 = @ip.face
						@tf2 = @ip.transformation
					end
					@ed2 = @ip.edge if @ip.edge#and face.parent.parent == model
					@ps2 = @ip.position
					@selection.add @fc2 if @fc2
					@selection.add @ed2 if @ed2
					self.increment_state(view) if @fc2
			end
		  end
		end
	end #Joint_Thinwall
	def add_menu()
		lang = ""#Sketchup.get_locale.upcase
		menuitem = "Extend_Trim_Faces"
		menuitem = "面と面を突き付ける" if lang == "JA" or lang == "JP"
		UI.menu("Plugins").add_item( menuitem ) {
			 #Joint_Thinwall.show_webdialog
			 Sketchup.active_model.select_tool Joint_Thinwall.new
		}
	end
end#Joint_Thinwall_Set

if(not file_loaded?("Extend_Trim_Faces.rb"))
	tak2jtset =Joint_Thinwall_Set.new
	tak2jtset.add_menu()
end

file_loaded("Extend_Trim_Faces.rb")
